//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_BOUNDING_BOX_H
#define GF_BOUNDING_BOX_H

#include "gfprimtv.h"

//@ManMemo: A shadable bounding box.
class GFBoundingBox: public GFPrimitive {
/*@DOC:
A shadable bounding box used for feedback purposes.
It is only visible in shading mode. This primitive is not
designed for usage via external API. Therefore some methods are empty.
*/
  public:
    //@ManMemo: Create bounding box with specified father.
    GFBoundingBox(GFPrimitive* = (GFPrimitive*)gfNoFather);

    virtual ~GFBoundingBox(void);
    
    //@ManMemo: Set visible bounding box.
    void setBounds(const GBounds3&);

    //@ManMemo: Make bounding box invisible.
    void unsetBounds(void);

    virtual bool isA(const GString &) const { return(false); }
    virtual const char *getDescription(void) const { return(0); }
    virtual const char *getClass(void) const { return(0); }

    virtual void saveConstr(ostream&) {}

    virtual void shade(void);
    // * GF SHADE LIBRARY *
  private:
    GShadablePolyline* mLine1;
    GShadablePolyline* mLine2;
};

#endif
