//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_FRAME_H
#define GF_FRAME_H

#include "gfprimtv.h"

extern const GString gfFrameID;

//@ManMemo: A solid frame.
class GFFrame: public GFPrimitive {
  public:
    //@ManMemo: Construct frame from values.
    GFFrame(const char*, const GVector3&, GFloat, GFPrimitive* = (GFPrimitive*)gfNoFather);

    //@ManMemo: Construct frame by copying an existing one.
    GFFrame(const char*, const GFFrame*, GFPrimitive* = (GFPrimitive*)gfNoFather);

    virtual ~GFFrame(void);

    virtual bool isA(const GString& pString) const {
	return(pString == gfFrameID);
    }

    virtual const char* getDescription(void) const { 
	return("An orthogonal frame in x-y plane. The frame starts at the local origin."); 
    }
    virtual const char* getClass(void) const { 
	return(gfFrameID); 
    }

    virtual void saveConstr(ostream&);
    
    const GVector3& getDimensions(void);
    GFloat getWidth(void);
  public:
    static GFObject* classCMD(GFArgc, GFArgs);
  private:
    virtual GFRenderable* getRenderable(void);
    class GFFrameP* mFrame;
};

#endif
