//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_IMAGE_H
#define GF_IMAGE_H

#include <render/gimage.h>
#include "gfrender.h"

extern bool gfImageMapping;

//@ManMemo: A shadable image mapping basing on an RGB file.
class GFImage: public GShadable {
  private:
    GFImage(const char*);
    // * GF SHADE LIBRARY *
  public:
    const char* getName(void) const { 
	return(mName);
    }
    const GImage& getImage(void) const {
	return(*mImage);
    }
    virtual void shade(void) {
	callDisplayList();
    }
    void setWidth(GFloat pW) {
	assert(pW >= 0.0);
	mSize.setX(pW);
    }
    GFloat getWidth(void) const {
	return(mSize.getX());
    }
    void setHeight(GFloat pH) {
	assert(pH >= 0.0);
	mSize.setY(pH);
    }
    GFloat getHeight(void) const {
	return(mSize.getY());
    }
  public:
    static GFImage* getImage(const char*);
  private:
    GSGIImage* mImage;
    GPoint2 mSize;

    GString mName;
    static GDLList<GFImage> sImages;
};

#endif
