//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_LOCATOR_H
#define GF_LOCATOR_H

#include <input/gdevice.h>
#include "gfprimtv.h"
#include "gftypes.h"
#include "gflookat.h"

//@ManMemo: An input device encapsulating a 3D location.
class GFLocator: public GInputDevice {
/*@Doc:
A locator will be triggered by a mouse motion event w/ pressed middle or
right button. The camera viewpoint and ref point may not change.
*/
  public:
   GFLocator(GFLookatCamera& pRend, 
	     GInputDevice* pFather = (GInputDevice*)gNoInputDevice): 
   GInputDevice(pFather), mRend(pRend), mOldX(-1), mDiff(0.0, 0.0, 0.0), 
   mAngle(0), mUpdate(false), mTranslOff(true), mRotOff(true) {}

   void setPosition(const GPoint3&);
   
   const GVector3& getTranslation(void) const {
       return(mDiff);
   }

   const GPoint3& getPosition(void) const {
       return(mPos);
   }

   GFloat getAngle(void) const {
       return(mAngle);
   }

   virtual bool event(GEvent*);

 private:
   GFLookatCamera& mRend;
   GFloat mOldX;
   GVector3 mDiff;
   GFloat mAngle;
   bool mUpdate;

   bool mNewPos; 
   GPoint3 mPos;

   GFloat mDist;
   bool mTranslOff;
   bool mRotOff;

   bool mMapZ;
};

#endif
