//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_MOVER_H
#define GF_MOVER_H

#include <input/gdevice.h>
#include "gflookat.h"

//@ManMemo: An input class for VR-like moving in the scene.
class GFMover: public GInputDevice {
/*@Doc:
An input class for VR-like moving in the scene. The mover
will not automatically cause an update. All rendering is done
by the locator which runs in parallel.
*/
  public:
    GFMover(GFLookatCamera&, GInputDevice* = (GInputDevice*)gNoInputDevice); 

    virtual bool event(GEvent*);
    virtual void on(void);
  private:
    void setupPosition(void);
  private:
    GFloat oldx, oldy;
    GFLookatCamera& mCamera;
    GFloat mAngle;
    GVector3 mPosition;

    bool mMoveOff;
};

#endif
