//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_OBJECT_H
#define GF_OBJECT_H

#ifdef GWITH_TCL

#include <stdarg.h>
#include <util/gtcl.h>
#include <util/gident.h>

#define gfHelp gTclHelp
#define gfFromString (char*)gTclFromString
#define gfToString gTclToString

typedef char* GFArg;
typedef GFArg* GFArgs;
typedef int GFArgc;

//@ManMemo: Base class for metafile accessible objects.
class GFObject: public GTclInterface {
  protected:
    GFObject(const char* pName): GTclInterface(pName) {}
  public:
    //@ManMemo: Return verbal description of the class purpose.
    virtual const char* getDescription(void) const = 0;

    const GString& getName(void) const {
	return(GTclInterface::getName());
    }
  protected:
    static GFObject* classCMD(GFArgc, GFArgs);
};

typedef enum {
    GF_OK = 0,
    GF_ERROR,
    GF_HELP
} GFInterpState;

//@ManMemo: Specific interpreter class.
class GFInterp {
  public:    
    static void setResult(const char*);
    static void setResult(const GString&);

    static void setResult(GFInterpState, const char* ...);

    static GFInterpState getState(void) {
	return(sState);
    }
  private:
    static GFInterpState sState;
    static GString sResult;
};

#endif

#ifdef GWITH_COBRA


#endif

GFInterpState gfInterpSplitList(const GFArg, GFArgc&, GFArgs&);
void gfInterpFreeList(GFArgs pList);

#endif
