//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_PICK_H
#define GF_PICK_H

#include <input/gdevice.h>
#include "gfprimtv.h"
#include "gftypes.h"
#include "gflookat.h"

//@ManMemo: A selection class that handles GF-specific pick style
class GFPick: public GInputDevice {
  public:
    //@ManMemo: Create pick device for passed camera.
    GFPick(GFLookatCamera& pRend, 
	   GInputDevice* pFather = (GInputDevice*)gNoInputDevice): 
    GInputDevice(pFather), mPrimitive(0), mRend(pRend), mCtrl(false) {}

    //@ManMemo: Get time to last event.
    const GTime& getRelativeTime(void) const {
	return(mDiffTime);
    }
    
    //@ManMemo: Inquire selected primitive.
    GFPrimitive* getSelection(void) const {
	return(mPrimitive);
    }
   
    //@ManMemo: Inquire state of keyboard.
    bool controlKey(void) const {
	return(mCtrl);
    }

    virtual bool event(GEvent*);
  private:
    GTime mDiffTime;
    GFPrimitive* mPrimitive;
    GFLookatCamera& mRend;
    bool mCtrl;
};

#endif
