//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_PIXMAP_H
#define GF_PIXMAP_H

#ifdef GWITH_TCL
#include "util/gtcl.h"
#endif

#include "render/gpixmap.h"
#include "util/gtempl.h"

extern const GString gfPixmapID;

//@ManMemo: The pixmap to render in.
class GFPixmap: public GPixmapDisplay, public GFObject {
  public:
    //@ManMemo: Create pixmap with specified name and initial dimensions.
    GFPixmap(const char*, int, int);

    virtual ~GFPixmap(void);

    virtual const char* getDescription(void) const {
	return("A pixel-oriented output device for immediate display. For \
that, it has to be associated with a camera. At least one pixmap must be \
created before the creation of graphical primitives.");
    }
    void saveAsBitmap(const char*);
    // * GF SHADE LIBRARY *
  public:
    // return specified pixmap or zero:
    static GFPixmap* getByName(const char*);
    const GString& getName(void) const {
	return(mName);
    }
    virtual GEvent* getEvent(void);
    // * GF SHADE LIBRARY *
    static GFObject* classCMD(GFArgc, GFArgs);
#ifdef GWITH_TCL
    virtual bool objectCMD(GFArgs);
#endif
  private:
    GString mName;
    static GDLList<GFPixmap> sList; 
};

#endif
