//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_PROGRAM_H
#define GF_PROGRAM_H

#include <util/gstring.h>
#include <util/gtempl.h>

//@ManMemo: A class representing a furniture or architecture program.
class GFProgram {
/*@Doc:
A class representing a furniture or architecture program.
No destructor needed, because a program cannot be deleted after creation.
All programs will be removed if the static list will be cleared.
*/
  private:
    GFProgram(const char* pName): mName(pName), mID(++sID) {
	sPrograms.append(this);
    }
  public:
    const GString& getName(void) const { 
	return(mName);
    }
    bool operator==(const GFProgram& pProgr) const {
	return(mID == pProgr.mID);
    }
  public:
    static void setProgram(const char*);
  private:
    GString mName;
    // unique program name
    int mID;
    // unique ID for the whole life time
  private:
    static int sID;
    static GDLList<GFProgram> sPrograms;
};

extern void gfSetProgram(const char*);
extern const char* gfGetProgram(void);

extern GFProgram* gfProgram;

#endif
