//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_SYMBOL_H
#define GF_SYMBOL_H

#include "gftext.h"

extern const GString gfSymbolID;

//@ManMemo: A primitive representing a number of invisible objects.
class GFSymbol: public GFPrimitive {
  public:
    //@ManMemo: Construct symbol with initial type and number.
    GFSymbol(const char*, const char*, int, GFPrimitive*);
    virtual ~GFSymbol(void);

    virtual bool isA(const GString& pString) const {
	return(pString == gfSymbolID);
    }

    virtual void saveConstr(ostream&); 
    
    virtual const char* getDescription(void) const { return("An invisible \
node representing a set of primitives of the same type."); }
    virtual const char* getClass(void) const { return(gfSymbolID); }

    //@ManMemo: Set new number of textual type.
    void setNumber(int);

    //@ManMemo: Inquire number of textual type.
    int getNumber(void) const;

    //@ManMemo: Set/change comment for symbol.
    void setComment(const char*);

    //@ManMemo: Inquire comment for symbol.
    const char* getComment(void) const;
  public:
    virtual void shade(void);
    // * GF SHADE LIBRARY *
    static GFObject* classCMD(GFArgc, GFArgs);
#ifdef GWITH_TCL
    virtual bool objectCMD(GFArgs);
#endif
  private:
    void setText(void);
  private:
    GString mType;
    int mNo;
    GFMText mText;
    char* mComment;
};

#endif
