//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GF_TOP_H
#define GF_TOP_H

#include "gfprimtv.h"
#include "gfprogr.h"

extern const GString gfTopID;

class GFLight;

//@ManMemo: Basic composite primitive.
class GFTop: public GFPrimitive {
  public:
    //@ManMemo: Create empty top object.
    GFTop(const char*, GFPrimitive* = (GFPrimitive*)gfNoFather);

    virtual bool isA(const GString& pString) const {
	return(pString == gfTopID);
    }

    void notSelectable(void) {
	setSelectionMode(GF_SELECT_FATHER);
    }

    bool isSelectable(void) {
	return(getSelectionMode() == GF_SELECTABLE);
    }

    virtual void saveConstr(ostream&); 
    
    virtual const char* getDescription(void) const { return("An invisible \
node for trees of primitives. Such a top node may be used to logically group \
objects. To change the topical furniture/architecture program, a top may be \
used as well."); }
    virtual const char* getClass(void) const { return(gfTopID); }

    const GFProgram* getProgram(void) const {
	return(mProgram);
    }
  public:
    void setLocalLight(GFLight* pLight) {
	// This light src must be a (indirect) child of this primitive!
	mLight = pLight;
    }
    virtual void shade(void);
    //* GF SHADE LIBRARY *
  public:
    static GFObject* classCMD(GFArgc, GFArgs);
#ifdef GWITH_TCL
    virtual bool objectCMD(GFArgs);
#endif
  protected:
    void saveProgram(ostream&); 
  private:
    GFProgram* mProgram;
    GFLight* mLight;
};

#endif
