//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
//////////////////////////////////////////////////////////////////////////////
// 3DS Chunk-IDs
//////////////////////////////////////////////////////////////////////////////

//// 0xxxH Group

#define 	NULL_CHUNK 		0x0000
//#define 	Unknown chunk 		0001H
//float	???	 	

#define 	M3D_VERSION 		0x0002	
//	short version;

#define 	M3D_KFVERSION  		0x0005

#define 	COLOR_F			0x0010
//	float red, grn, blu;  	

#define 	COLOR_24		0x0011
//	char red, grn, blu;  	

#define 	LIN_COLOR_24  		0x0012
//	char red, grn, blu;

#define 	LIN_COLOR_F  		0x0013
//	float red, grn, blu;

#define 	INT_PERCENTAGE  	0x0030
//	short percentage;

#define 	FLOAT_PERCENTAGE  	0x0031
//	float percentage;

#define 	MASTER_SCALE		0x0100
//	float scale;  	

#define 	ChunkType  		0x0995

#define 	ChunkUnique  		0x0996
#define 	NotChunk  		0x0997
#define 	Container  		0x0998
#define 	IsChunk  		0x0999
#define 	C_SXP_SELFI_MASKDATA  	0x0c3c

//////////////////////////////////////////////////////////////////////////////
//// 1xxxH Group
//////////////////////////////////////////////////////////////////////////////

#define 	BIT_MAP			0x1100
//	cstr filename;  	

#define 	USE_BIT_MAP  		0x1101
#define 	SOLID_BGND  		0x1200
//followed by color_f

#define 	USE_SOLID_BGND  	0x1201
#define 	V_GRADIENT		0x1300
//followed by three color_f: start, mid, end
//	float midpoint;  	


/*****************************************************************************
#define 0x1301	USE_V_GRADIENT  	
#define 0x1400	LO_SHADOW_BIAS
//	float bias;  	

#define 0x1410	HI_SHADOW_BIAS  	
#define 0x1420	SHADOW_MAP_SIZE
//	short size;  	

#define 0x1430	SHADOW_SAMPLES  	
#define 0x1440	SHADOW_RANGE  	
#define 0x1450	SHADOW_FILTER
//	float filter;  	

#define 0x1460	RAY_BIAS 
//	float bias; 	

#define 0x1500	O_CONSTS
//	float plane_x, plane_y, plane_z;  	

*****************************************************************************/


//////////////////////////////////////////////////////////////////////////////
//// 2xxxH Group
//////////////////////////////////////////////////////////////////////////////

#define 	AMBIENT_LIGHT  		0x2100
#define 	FOG			0x2200
// followed by color_f, fog_bgnd
//	float near_plane, near_density;
//	float far_plane, far_density;  	

#define 	USE_FOG  		0x2201
#define 	FOG_BGND  		0x2210
#define 	DISTANCE_CUE		0x2300
// followed by dcue_bgnd
//	float near_plane, near_density;
//	float far_plane, far_density;  	


/*****************************************************************************
#define 0x2301	USE_DISTANCE_CUE  	
#define 0x2302	LAYER_FOG
//	float fog_z_from, fog_z_to;
//	float fog_density;
//	short fog_type;  	

#define 0x2303	USE_LAYER_FOG  	
#define 0x2310	DCUE_BGND  	
#define 0x2d2d	SMAGIC  	
#define 0x2d3d	LMAGIC  	

*****************************************************************************/


//////////////////////////////////////////////////////////////////////////////
// 3xxxH Group
//////////////////////////////////////////////////////////////////////////////

#define 	DEFAULT_VIEW  		0x3000
#define 	VIEW_TOP  		0x3010
//	float targe_x, target_y, target_z;
//	float view_width;  	

#define 	VIEW_BOTTOM  		0x3020
//	float targe_x, target_y, target_z;
//	float view_width;  	

#define 	VIEW_LEFT  		0x3030
//	float targe_x, target_y, target_z;
//	float view_width;  	

#define 	VIEW_RIGHT  		0x3040
//	float targe_x, target_y, target_z;
//	float view_width;  	

#define 	VIEW_FRONT		0x3050
//	float targe_x, target_y, target_z;
//	float view_width;  	

#define 	VIEW_BACK  		0x3060
//	float targe_x, target_y, target_z;
//	float view_width;  	

#define 	VIEW_USER  		0x3070
//	float targe_x, target_y, target_z;
//	float view_width;  	

#define 	VIEW_CAMERA		0x3080
//	cstr camera_name;  	

#define 	VIEW_WINDOW  		0x3090

#define 	MDATA  			0x3d3d
// Mesh Data Magic Number (.3DS files sub of 4d4d)

#define 	MESH_VERSION  		0x3d3e
#define 	MLIBMAGIC  		0x3daa
// Material Library Magic Number (.MLI files)

#define 	PRJMAGIC		0x3dc2
//3dS Project Magic Number (.PRJ files)

#define 	MATMAGIC  		0x3dff
//Material File Magic Number (.MAT files)


//////////////////////////////////////////////////////////////////////////////
// 4xxxH Group
//////////////////////////////////////////////////////////////////////////////

#define 	NAMED_OBJECT 		0x4000
//	cstr name;

#define 	OBJ_HIDDEN  		0x4010
#define 	OBJ_VIS_LOFTER  	0x4011
#define 	OBJ_DOESNT_CAST  	0x4012
#define 	OBJ_MATTE  		0x4013
#define 	OBJ_FAST  		0x4014
#define 	OBJ_PROCEDURAL  	0x4015
#define 	OBJ_FROZEN  		0x4016
#define 	OBJ_DONT_RCVSHADOW  	0x4017

#define 	N_TRI_OBJECT  		0x4100
// named triangle object
// followed by point_array, point_flag_array, mesh_matrix, face_array 

#define 	POINT_ARRAY		0x4110
//	short npoints;
//	struct {
//	 float x, y, z;
//	}points[npoints];  	

#define 	POINT_FLAG_ARRAY	0x4111       
//	short nflags;
//	short flags[nflags];  	

#define 	FACE_ARRAY		0x4120
// may be followed by smooth_group
//	short nfaces;
//	struct {
//	  short vertex1, vertex2, vertex3;
//	  short flags;
//	}  facearray[nfaces];

#define 	MSH_MAT_GROUP 		0x4130
//// mesh_material_group
//	cstr material_name;
// 	short nfaces;
//	short facenum[nfaces];

#define 	OLD_MAT_GROUP  		0x4131
#define 	TEX_VERTS		0x4140
//	short nverts;
//	struct {
//	  float x, y;
//	}  vertices[nverts];  	

#define 	SMOOTH_GROUP		0x4150
//	short grouplist[n]	determined by length, seems to be 4 per face  	

#define 	MESH_MATRIX		0x4160
//	float matrix[4][3];  	

#define 	MESH_COLOR		0x4165
//	short color_index;  	

#define 	MESH_TEXTURE_INFO 	0x4170
//      short map_type;
//	float x_tiling, y_tiling;
//	float icon_x, icon_y, icon_z;
//	float matrix[4][3];
//	float scaling, plan_icon_w, plan_icon_h, cyl_icon_h;


/*****************************************************************************
#define 0x4181	PROC_NAME  	
#define 0x4182	PROC_DATA  	
#define 0x4190	MSH_BOXMAP  	
#define 0x4400	N_D_L_OLD  	
#define 0x4500	N_CAM_OLD  	
*****************************************************************************/


#define 	N_DIRECT_LIGHT  	0x4600
//followed by color_f
//	float x, y, z;

#define 	DL_SPOTLIGHT		0x4610
//	float target_x, target_y, target_z;
//	float hotspot_ang;
//	float falloff_ang;  	

#define 	DL_OFF  		0x4620


/*****************************************************************************
#define 0x4625	DL_ATTENUATE  	
#define 0x4627	DL_RAYSHAD  	
#define 0x4630	DL_SHADOWED  	
#define 0x4640	DL_LOCAL_SHADOW  	
#define 0x4641	DL_LOCAL_SHADOW2  	
#define 0x4650	DL_SEE_CONE  	
#define 0x4651	DL_SPOT_RECTANGULAR  	
#define 0x4652	DL_SPOT_OVERSHOOT  	
#define 0x4653	DL_SPOT_PROJECTOR  	
#define 0x4654	DL_EXCLUDE  	
#define 0x4655	DL_RANGE  	
#define 0x4656	DL_SPOT_ROLL
//	float roll_ang;  	

#define 0x4657	DL_SPOT_ASPECT  	
#define 0x4658	DL_RAY_BIAS
//	float bias;  	

#define 0x4659	DL_INNER_RANGE
//	float range;  	
#define 0x465a	DL_OUTER_RANGE 
//	float range; 	

#define 0x465b	DL_MULTIPLIER
//	float multiple;  	
#define 0x4680	N_AMBIENT_LIGHT  	
*****************************************************************************/



#define 	N_CAMERA 		0x4700
//	float camera_x, camera_y, camera_z;
//	float target_x, target_y, target_z;
//	float bank_angle;
//	float focus; 	

#define 	CAM_SEE_CONE  		0x4710
#define 	CAM_RANGES		0x4720
//	float near_range, far_range;  	

#define 	M3DMAGIC  		0x4d4d
// 3DS Magic Number (.3DS file)


/*****************************************************************************
#define 0x4f00	HIERARCHY  	
#define 0x4f10	PARENT_OBJECT  	
#define 0x4f20	PIVOT_OBJECT  	
#define 0x4f30	PIVOT_LIMITS  	
#define 0x4f40	PIVOT_ORDER  	
#define 0x4f50	XLATE_RANGE  	


//////////////////////////////////////////////////////////////////////////////
// 5xxxH Group
//////////////////////////////////////////////////////////////////////////////
5000H	POLY_2D  	
5010H	SHAPE_OK  	
5011H	SHAPE_NOT_OK  	
5020H	SHAPE_HOOK  	


6xxxH Group

6000H	PATH_3D  	
6005H	PATH_MATRIX  	
6010H	SHAPE_2D  	
6020H	M_SCALE  	
6030H	M_TWIST  	
6040H	M_TEETER  	
6050H	M_FIT  	
6060H	M_BEVEL  	
6070H	XZ_CURVE  	
6080H	YZ_CURVE  	
6090H	INTERPCT  	
60a0H	DEFORM_LIMIT  	
6100H	USE_CONTOUR  	
6110H	USE_TWEEN  	
6120H	USE_SCALE  	
6130H	USE_TWIST  	
6140H	USE_TEETER  	
6150H	USE_FIT  	
6160H	USE_BEVEL  	

//////////////////////////////////////////////////////////////////////////////
// 7xxxH Group
//////////////////////////////////////////////////////////////////////////////
7000H	VIEWPORT_LAYOUT_OLD  	
7001H	VIEWPORT_LAYOUT  	followed by viewport_size, viewport_data
	short form, top, ready, wstate, swapws, swapport, swapcur;
7010H	VIEWPORT_DATA_OLD  	
7011H	VIEWPORT_DATA  
	short flags, axis_lockout;
	short win_x, win_y, win_w, winh_, win_view;
	float zoom; 
	float worldcenter_x, worldcenter_y, worldcenter_z;
	float horiz_ang, vert_ang;
	cstr camera_name;
7012H	VIEWPORT_DATA_3 
	short flags, axis_lockout;
	short win_x, win_y, win_w, winh_, win_view;
	float zoom; 
	float worldcenter_x, worldcenter_y, worldcenter_z;
	float horiz_ang, vert_ang;
	cstr camera_name;
7020H	VIEWPORT_SIZE  	
	short x, y, w, h;
7030H	NETWORK_VIEW  	

//////////////////////////////////////////////////////////////////////////////
// 8xxxH Group
//////////////////////////////////////////////////////////////////////////////
8000H	XDATA_SECTION  	
8001H	XDATA_ENTRY  	
8002H	XDATA_APPNAME  	
8003H	XDATA_STRING  	
8004H	XDATA_FLOAT  	
8005H	XDATA_DOUBLE  	
8006H	XDATA_SHORT  	
8007H	XDATA_LONG  	
8008H	XDATA_VOID  	
8009H	XDATA_GROUP  	
800aH	XDATA_RFU6  	
800bH	XDATA_RFU5  	
800cH	XDATA_RFU4  	
800dH	XDATA_RFU3  	
800eH	XDATA_RFU2  	
800fH	XDATA_RFU1  	
80f0H	PARENT_NAME  	

*****************************************************************************/

//////////////////////////////////////////////////////////////////////////////
// 0xAxxx Group
//////////////////////////////////////////////////////////////////////////////
#define 	MAT_NAME		0xa000
//	cstr material_name;  	

#define 	MAT_AMBIENT  		0xa010
// followed by color chunk

#define 	MAT_DIFFUSE  		0xa020
// followed by color chunk

#define 	MAT_SPECULAR  		0xa030
// followed by color chunk

#define 	MAT_SHININESS  		0xa040
// followed by percentage chunk

#define 	MAT_SHIN2PCT  		0xa041
// followed by percentage chunk

#define 	MAT_SHIN3PCT  		0xa042
//followed by percentage chunk


#define 	MAT_TRANSPARENCY  	0xa050
// followed by percentage chunk

#define 	MAT_XPFALL  		0xa052
// followed by percentage chunk
#define 	MAT_REFBLUR  		0xa053
// followed by percentage chunk

#define 	MAT_SELF_ILLUM  	0xa080
#define 	MAT_TWO_SIDE  		0xa081
#define 	MAT_DECAL  		0xa082
#define 	MAT_ADDITIVE  		0xa083
#define 	MAT_SELF_ILPCT  	0xa084
// followed by percentage chunk	

#define 	MAT_WIRE  		0xa085
#define 	MAT_SUPERSMP  		0xa086
#define 	MAT_WIRESIZE		0xa087
//	float wire_size;  	

#define 	MAT_FACEMAP  		0xa088
#define 	MAT_XPFALLIN  		0xa08a
#define 	MAT_PHONGSOFT  		0xa08c
#define 	MAT_WIREABS  		0xa08e
#define 	MAT_SHADING		0xa100
//	short shading_value;  	

#define 	MAT_TEXMAP  		0xa200
// followed by percentage chunk, mat_mapname, mat_map_tiling, mat_map_texblur...

#define 	MAT_SPECMAP  		0xa204
// followed by percentage_chunk, mat_mapname

#define 	MAT_OPACMAP  		0xa210
// followed by percentage_chunk, mat_mapname

#define 	MAT_REFLMAP  		0xa220
// followed by percentage_chunk, mat_mapname

#define 	MAT_BUMPMAP  		0xa230
// followed by percentage_chunk, mat_mapname

#define 	MAT_USE_XPFALL  	0xa240
#define 	MAT_USE_REFBLUR  	0xa250
#define 	MAT_BUMP_PERCENT  	0xa252
#define 	MAT_MAPNAME 		0xa300
//	cstr filename; 	

#define 	MAT_ACUBIC  		0xa310

/*****************************************************************************
#define 0xa320	MAT_SXP_TEXT_DATA  	
#define 0xa321	MAT_SXP_TEXT2_DATA  	
#define 0xa322	MAT_SXP_OPAC_DATA  	
#define 0xa324	MAT_SXP_BUMP_DATA  	
#define 0xa325	MAT_SXP_SPEC_DATA  	
#define 0xa326	MAT_SXP_SHIN_DATA  	
#define 0xa328	MAT_SXP_SELFI_DATA  	
#define 0xa32a	MAT_SXP_TEXT_MASKDATA  	
#define 0xa32c	MAT_SXP_TEXT2_MASKDATA  	
#define 0xa32e	MAT_SXP_OPAC_MASKDATA  	
#define 0xa330	MAT_SXP_BUMP_MASKDATA  	
#define 0xa332	MAT_SXP_SPEC_MASKDATA  	
#define 0xa334	MAT_SXP_SHIN_MASKDATA  	
#define 0xa336	MAT_SXP_SELFI_MASKDATA  	
#define 0xa338	MAT_SXP_REFL_MASKDATA  	
#define 0xa33a	MAT_TEX2MAP  	
#define 0xa33c	MAT_SHINMAP  	
#define 0xa33d	MAT_SELFIMAP  	
#define 0xa33e	MAT_TEXMASK  	
#define 0xa340	MAT_TEX2MASK  	
#define 0xa342	MAT_OPACMASK  	
#define 0xa344	MAT_BUMPMASK  	
#define 0xa346	MAT_SHINMASK  	
#define 0xa348	MAT_SPECMASK  	
#define 0xa34a	MAT_SELFIMASK  	
#define 0xa34c	MAT_REFLMASK  	
a350H	MAT_MAP_TILINGOLD  	
a351H	MAT_MAP_TILING
	short flags;  	
a352H	MAT_MAP_TEXBLUR_OLD  	
a353H	MAT_MAP_TEXBLUR
	float blurring;  	
a354H	MAT_MAP_USCALE  	
a356H	MAT_MAP_VSCALE  	
a358H	MAT_MAP_UOFFSET  	
a35aH	MAT_MAP_VOFFSET  	
a35cH	MAT_MAP_ANG  	
a360H	MAT_MAP_COL1  	
a362H	MAT_MAP_COL2  	
a364H	MAT_MAP_RCOL  	
a366H	MAT_MAP_GCOL  	
a368H	MAT_MAP_BCOL  	

*****************************************************************************/

#define 	MAT_ENTRY  		0xafff






/*****************************************************************************
//////////////////////////////////////////////////////////////////////////////
// BxxxH Group
//////////////////////////////////////////////////////////////////////////////
b000H	KFDATA  	followed by kfhdr
b001H	AMBIENT_NODE_TAG  	
b002H	OBJECT_NODE_TAG  	followed by node_hdr, pivot, pos_track_tag, 
			rot_track_tag, scl_track_tag, morph_smooth...
b003H	CAMERA_NODE_TAG  	followed by node_hdr, pos_track_tag, fov_track_tag,
			roll_track_tag...
b004H	TARGET_NODE_TAG  	followed by node_hdr, pos_track_tag...
b005H	LIGHT_NODE_TAG  	followed by node_hdr, pos_track_tag, col_track_tag...
b006H	L_TARGET_NODE_TAG  	followed by node_id, node_hdr, pos_track_tag
b007H	SPOTLIGHT_NODE_TAG  followed by node_id, node_hdr, pos_track_tag, 			
		hot_track_tag, fall_track_tag, roll_track_tag,
			col_track_tag...
b008H	KFSEG  
	short start, end;	
b009H	KFCURTIME 
	short curframe; 	
b00aH	KFHDR  	followed by viewport_layout, kfseg, kfcurtime, 
			object_node_tag, light_node_tag, target_node_tag,
			camera_node_tag, l_target_node_tag, spotlight_node_tag
			ambient_node_tag...
	short revision; 
	cstr filename; 
	short animlen;
b010H	NODE_HDR
	cstr objname;
	short flags1;
	short flags2;  	
	short heirarchy;	? 
b011H	INSTANCE_NAME  	
b012H	PRESCALE  	
b013H	PIVOT
	float pivot_x, pivot_y, pivot_z;  	
b014H	BOUNDBOX  	
b015H	MORPH_SMOOTH 
	float morph_smoothing_angle_rad; 	
b020H	POS_TRACK_TAG
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		float pos_x, pos_y, pos_z; 
		}  pos[keys]; 	

b021H	ROT_TRACK_TAG  	
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		float rotation_rad;
		float axis_x, axis_y, axis_z;  
		}  rot[keys];	
b022H	SCL_TRACK_TAG  	
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		float scale_x, scale_y, scale_z; 
		}  scale[keys]; 	
b023H	FOV_TRACK_TAG
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		float camera_field_of_view;
		}  fov[keys]  	
b024H	ROLL_TRACK_TAG
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		float camera_roll;
		}  roll[keys];  	



b025H	COL_TRACK_TAG  	
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		float red, rgn, blu;
		}  color[keys];
b026H	MORPH_TRACK_TAG  	
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		cstr obj_name;
		}  morph[keys];
b027H	HOT_TRACK_TAG  	
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		float hotspot_ang;
		}  hotspot[keys];
b028H	FALL_TRACK_TAG  	
	short flags;
	short unknown[4];
	short keys;
	short unknown;
	struct {
		short framenum;
		long unknown;
		float falloff_ang;
		}  falloff[keys];
b029H	HIDE_TRACK_TAG  	
b030H	NODE_ID  
	short id;	

//////////////////////////////////////////////////////////////////////////////
// CxxxH Group
//////////////////////////////////////////////////////////////////////////////
c010H	C_MDRAWER  	
c020H	C_TDRAWER  	
c030H	C_SHPDRAWER  	
c040H	C_MODDRAWER  	
c050H	C_RIPDRAWER  	
c060H	C_TXDRAWER  	
c062H	C_PDRAWER  	
c064H	C_MTLDRAWER  	
c066H	C_FLIDRAWER  	
c067H	C_CUBDRAWER  	
c070H	C_MFILE  	
c080H	C_SHPFILE  	
c090H	C_MODFILE  	
c0a0H	C_RIPFILE  	
c0b0H	C_TXFILE  	
c0b2H	C_PFILE  	
c0b4H	C_MTLFILE  	
c0b6H	C_FLIFILE  	
c0b8H	C_PALFILE  	
c0c0H	C_TX_STRING  	
c0d0H	C_CONSTS  	
c0e0H	C_SNAPS  	
c0f0H	C_GRIDS  	
c100H	C_ASNAPS  	
c110H	C_GRID_RANGE  	
c120H	C_RENDTYPE  	
c130H	C_PROGMODE  	
c140H	C_PREVMODE  	
c150H	C_MODWMODE  	
c160H	C_MODMODEL  	
c170H	C_ALL_LINES  	
c180H	C_BACK_TYPE  	
c190H	C_MD_CS  	
c1a0H	C_MD_CE  	
c1b0H	C_MD_SML  	
c1c0H	C_MD_SMW  	
c1c3H	C_LOFT_WITH_TEXTURE  	
c1c4H	C_LOFT_L_REPEAT  	
c1c5H	C_LOFT_W_REPEAT  	
c1c6H	C_LOFT_UV_NORMALIZE  	
c1c7H	C_WELD_LOFT  	
c1d0H	C_MD_PDET  	
c1e0H	C_MD_SDET  	
c1f0H	C_RGB_RMODE  	
c200H	C_RGB_HIDE  	
c202H	C_RGB_MAPSW  	
c204H	C_RGB_TWOSIDE  	
c208H	C_RGB_SHADOW  	
c210H	C_RGB_AA  	
c220H	C_RGB_OVW  	
c230H	C_RGB_OVH  	
c23dH	CMAGIC  	
c240H	C_RGB_PICTYPE  	
c250H	C_RGB_OUTPUT  	
c253H	C_RGB_TODISK  	
c254H	C_RGB_COMPRESS  	
c255H	C_JPEG_COMPRESSION  	
c256H	C_RGB_DISPDEV  	
c259H	C_RGB_HARDDEV  	
c25aH	C_RGB_PATH  	
c25bH	C_BITMAP_DRAWER  	
c260H	C_RGB_FILE  	
c270H	C_RGB_OVASPECT  	
c271H	C_RGB_ANIMTYPE  	
c272H	C_RENDER_ALL  	
c273H	C_REND_FROM  	
c274H	C_REND_TO  	
c275H	C_REND_NTH  	
c276H	C_PAL_TYPE  	
c277H	C_RND_TURBO  	
c278H	C_RND_MIP  	
c279H	C_BGND_METHOD  	
c27aH	C_AUTO_REFLECT  	
c27bH	C_VP_FROM  	
c27cH	C_VP_TO  	
c27dH	C_VP_NTH  	
c27eH	C_REND_TSTEP  	
c27fH	C_VP_TSTEP  	
c280H	C_SRDIAM  	
c290H	C_SRDEG  	
c2a0H	C_SRSEG  	
c2b0H	C_SRDIR  	
c2c0H	C_HETOP  	
c2d0H	C_HEBOT  	
c2e0H	C_HEHT  	
c2f0H	C_HETURNS  	
c300H	C_HEDEG  	
c310H	C_HESEG  	
c320H	C_HEDIR  	
c330H	C_QUIKSTUFF  	
c340H	C_SEE_LIGHTS  	
c350H	C_SEE_CAMERAS  	
c360H	C_SEE_3D  	
c370H	C_MESHSEL  	
c380H	C_MESHUNSEL  	
c390H	C_POLYSEL  	
c3a0H	C_POLYUNSEL  	
c3a2H	C_SHPLOCAL  	
c3a4H	C_MSHLOCAL  	
c3b0H	C_NUM_FORMAT  	
c3c0H	C_ARCH_DENOM  	
c3d0H	C_IN_DEVICE  	
c3e0H	C_MSCALE  	
c3f0H	C_COMM_PORT  	
c400H	C_TAB_BASES  	
c410H	C_TAB_DIVS  	
c420H	C_MASTER_SCALES  	
c430H	C_SHOW_1STVERT  	
c440H	C_SHAPER_OK  	
c450H	C_LOFTER_OK  	
c460H	C_EDITOR_OK  	
c470H	C_KEYFRAMER_OK  	
c480H	C_PICKSIZE  	
c490H	C_MAPTYPE  	
c4a0H	C_MAP_DISPLAY  	
c4b0H	C_TILE_XY  	
c4c0H	C_MAP_XYZ  	
c4d0H	C_MAP_SCALE  	
c4e0H	C_MAP_MATRIX_OLD  	
c4e1H	C_MAP_MATRIX  	
c4f0H	C_MAP_WID_HT  	
c500H	C_OBNAME  	
c510H	C_CAMNAME  	
c520H	C_LTNAME  	
c525H	C_CUR_MNAME  	
c526H	C_CURMTL_FROM_MESH  	
c527H	C_GET_SHAPE_MAKE_FACES  	
c530H	C_DETAIL  	
c540H	C_VERTMARK  	
c550H	C_MSHAX  	
c560H	C_MSHCP  	
c570H	C_USERAX  	
c580H	C_SHOOK  	
c590H	C_RAX  	
c5a0H	C_STAPE  	
c5b0H	C_LTAPE  	
c5c0H	C_ETAPE  	
c5c8H	C_KTAPE  	
c5d0H	C_SPHSEGS  	
c5e0H	C_GEOSMOOTH  	
c5f0H	C_HEMISEGS  	
c600H	C_PRISMSEGS  	
c610H	C_PRISMSIDES  	
c620H	C_TUBESEGS  	
c630H	C_TUBESIDES  	
c640H	C_TORSEGS  	
c650H	C_TORSIDES  	
c660H	C_CONESIDES  	
c661H	C_CONESEGS  	
c670H	C_NGPARMS  	
c680H	C_PTHLEVEL  	
c690H	C_MSCSYM  	
c6a0H	C_MFTSYM  	
c6b0H	C_MTTSYM  	
c6c0H	C_SMOOTHING  	
c6d0H	C_MODICOUNT  	
c6e0H	C_FONTSEL  	
c6f0H	C_TESS_TYPE  	
c6f1H	C_TESS_TENSION  	
c700H	C_SEG_START  	
c705H	C_SEG_END  	
c710H	C_CURTIME  	
c715H	C_ANIMLENGTH  	
c720H	C_PV_FROM  	
c725H	C_PV_TO  	
c730H	C_PV_DOFNUM  	
c735H	C_PV_RNG  	
c740H	C_PV_NTH  	
c745H	C_PV_TYPE  	
c750H	C_PV_METHOD  	
c755H	C_PV_FPS  	
c765H	C_VTR_FRAMES  	
c770H	C_VTR_HDTL  	
c771H	C_VTR_HD  	
c772H	C_VTR_TL  	
c775H	C_VTR_IN  	
c780H	C_VTR_PK  	
c785H	C_VTR_SH  	
c790H	C_WORK_MTLS  	
c792H	C_WORK_MTLS_2  	
c793H	C_WORK_MTLS_3  	
c794H	C_WORK_MTLS_4  	
c7a1H	C_BGTYPE  	
c7b0H	C_MEDTILE  	
c7d0H	C_LO_CONTRAST  	
c7d1H	C_HI_CONTRAST  	
c7e0H	C_FROZ_DISPLAY  	
c7f0H	C_BOOLWELD  	
c7f1H	C_BOOLTYPE  	
c900H	C_ANG_THRESH  	
c901H	C_SS_THRESH  	
c903H	C_TEXTURE_BLUR_DEFAULT  	
ca00H	C_MAPDRAWER  	
ca01H	C_MAPDRAWER1  	
ca02H	C_MAPDRAWER2  	
ca03H	C_MAPDRAWER3  	
ca04H	C_MAPDRAWER4  	
ca05H	C_MAPDRAWER5  	
ca06H	C_MAPDRAWER6  	
ca07H	C_MAPDRAWER7  	
ca08H	C_MAPDRAWER8  	
ca09H	C_MAPDRAWER9  	
ca10H	C_MAPDRAWER_ENTRY  	
ca20H	C_BACKUP_FILE  	
ca21H	C_DITHER_256  	
ca22H	C_SAVE_LAST  	
ca23H	C_USE_ALPHA  	
ca24H	C_TGA_DEPTH  	
ca25H	C_REND_FIELDS  	
ca26H	C_REFLIP  	
ca27H	C_SEL_ITEMTOG  	
ca28H	C_SEL_RESET  	
ca29H	C_STICKY_KEYINF  	
ca2aH	C_WELD_THRESHOLD  	
ca2bH	C_ZCLIP_POINT  	
ca2cH	C_ALPHA_SPLIT  	
ca30H	C_KF_SHOW_BACKFACE  	
ca40H	C_OPTIMIZE_LOFT  	
ca42H	C_TENS_DEFAULT  	
ca44H	C_CONT_DEFAULT  	
ca46H	C_BIAS_DEFAULT  	
ca50H	C_DXFNAME_SRC   	
ca60H	C_AUTO_WELD   	
ca70H	C_AUTO_UNIFY   	
ca80H	C_AUTO_SMOOTH   	
ca90H	C_DXF_SMOOTH_ANG   	
caa0H	C_SMOOTH_ANG   	
cb00H	C_WORK_MTLS_5  	
cb01H	C_WORK_MTLS_6  	
cb02H	C_WORK_MTLS_7  	
cb03H	C_WORK_MTLS_8  	
cb04H	C_WORKMTL  	
cb10H	C_SXP_TEXT_DATA  	
cb11H	C_SXP_OPAC_DATA  	
cb12H	C_SXP_BUMP_DATA  	
cb13H	C_SXP_SHIN_DATA  	
cb20H	C_SXP_TEXT2_DATA  	
cb24H	C_SXP_SPEC_DATA  	
cb28H	C_SXP_SELFI_DATA  	
cb30H	C_SXP_TEXT_MASKDATA  	
cb32H	C_SXP_TEXT2_MASKDATA  	
cb34H	C_SXP_OPAC_MASKDATA  	
cb36H	C_SXP_BUMP_MASKDATA  	
cb38H	C_SXP_SPEC_MASKDATA  	
cb3aH	C_SXP_SHIN_MASKDATA  	
cb3eH	C_SXP_REFL_MASKDATA  	
cc00H	C_NET_USE_VPOST  	
cc10H	C_NET_USE_GAMMA  	
cc20H	C_NET_FIELD_ORDER  	
cd00H	C_BLUR_FRAMES  	
cd10H	C_BLUR_SAMPLES  	
cd20H	C_BLUR_DUR  	
cd30H	C_HOT_METHOD  	
cd40H	C_HOT_CHECK  	
cd50H	C_PIXEL_SIZE  	
cd60H	C_DISP_GAMMA  	
cd70H	C_FBUF_GAMMA  	
cd80H	C_FILE_OUT_GAMMA  	
cd82H	C_FILE_IN_GAMMA  	
cd84H	C_GAMMA_CORRECT  	
cd90H	C_APPLY_DISP_GAMMA  	
cda0H	C_APPLY_FBUF_GAMMA  	
cdb0H	C_APPLY_FILE_GAMMA  	
cdc0H	C_FORCE_WIRE  	
cdd0H	C_RAY_SHADOWS  	
cde0H	C_MASTER_AMBIENT  	
cdf0H	C_SUPER_SAMPLE  	
ce00H	C_OBJECT_MBLUR  	
ce10H	C_MBLUR_DITHER  	
ce20H	C_DITHER_24  	
ce30H	C_SUPER_BLACK  	
ce40H	C_SAFE_FRAME  	
ce50H	C_VIEW_PRES_RATIO  	
ce60H	C_BGND_PRES_RATIO  	
ce70H	C_NTH_SERIAL_NUM  	

//////////////////////////////////////////////////////////////////////////////
// DxxxH Group
//////////////////////////////////////////////////////////////////////////////
d000H	VPDATA  	
d100H	P_QUEUE_ENTRY  	
d110H	P_QUEUE_IMAGE  	
d114H	P_QUEUE_USEIGAMMA  	
d120H	P_QUEUE_PROC  	
d130H	P_QUEUE_SOLID  	
d140H	P_QUEUE_GRADIENT  	
d150H	P_QUEUE_KF  	
d152H	P_QUEUE_MOTBLUR  	
d153H	P_QUEUE_MB_REPEAT  	
d160H	P_QUEUE_NONE  	
d180H	P_QUEUE_RESIZE  	
d185H	P_QUEUE_OFFSET  	
d190H	P_QUEUE_ALIGN  	
d1a0H	P_CUSTOM_SIZE  	
d210H	P_ALPH_NONE  	
d220H	P_ALPH_PSEUDO  	
d221H	P_ALPH_OP_PSEUDO  	
d222H	P_ALPH_BLUR  	
d225H	P_ALPH_PCOL  	
d230H	P_ALPH_C0  	
d231H	P_ALPH_OP_KEY  	
d235H	P_ALPH_KCOL  	
d238H	P_ALPH_OP_NOCONV  	
d240H	P_ALPH_IMAGE  	
d250H	P_ALPH_ALPHA  	
d260H	P_ALPH_QUES  	
d265H	P_ALPH_QUEIMG  	
d270H	P_ALPH_CUTOFF  	
d280H	P_ALPHANEG  	
d300H	P_TRAN_NONE  	
d310H	P_TRAN_IMAGE  	
d312H	P_TRAN_FRAMES  	
d320H	P_TRAN_FADEIN  	
d330H	P_TRAN_FADEOUT  	
d340H	P_TRANNEG  	
d400H	P_RANGES  	
d500H	P_PROC_DATA  	

//////////////////////////////////////////////////////////////////////////////
// FxxxH Group
//////////////////////////////////////////////////////////////////////////////
f020H	POS_TRACK_TAG_KEY  	
f021H	ROT_TRACK_TAG_KEY  	
f022H	SCL_TRACK_TAG_KEY  	
f023H	FOV_TRACK_TAG_KEY  	
f024H	ROLL_TRACK_TAG_KEY  	
f025H	COL_TRACK_TAG_KEY  	
f026H	MORPH_TRACK_TAG_KEY  	
f027H	HOT_TRACK_TAG_KEY  	
f028H	FALL_TRACK_TAG_KEY  	
f110H	POINT_ARRAY_ENTRY  	
f111H	POINT_FLAG_ARRAY_ENTRY  	
f120H	FACE_ARRAY_ENTRY  	
f130H	MSH_MAT_GROUP_ENTRY  	
f140H	TEX_VERTS_ENTRY  	
f150H	SMOOTH_GROUP_ENTRY  	
ffffH	DUMMY  

*****************************************************************************/
