//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////

#ifndef __GX_CSG_H__
#define __GX_CSG_H__

#include "gx/gx_defs.h"
#include "gx/gx_obj.h"

class GRayTraceable;

/// CSG-Intersection 
class GX_CSG_Intersection: public GXPrimitive {
  public:
    ///
    GX_CSG_Intersection(const GXObjectList&);
    virtual ~GX_CSG_Intersection(void);
    ///
    bool intersect(const GRay3&, GInterSectionList&);
    ///
    GVector3 getNormal(const GPoint3& rPoint);
    ///
    const GSurface& getSurface(const GPoint3&);
    
 private:
    GRayTraceable *mLastChild;
    GXObjectList mChildrenList;
    
    virtual const GBounds3& computeBounds(void);
};

/// CSG-Union 
class GX_CSG_Union: public GXPrimitive {
  public:
    ///
    GX_CSG_Union(const GXObjectList&);
    virtual ~GX_CSG_Union(void);
    
    ///
    bool intersect(const GRay3&, GInterSectionList&);
    ///
    GVector3 getNormal(const GPoint3& rPoint);
    
 private:
    GXObjectList mChildrenList;
    virtual const GBounds3& computeBounds(void);
};


/// CSG-Difference
class GX_CSG_Difference: public GXPrimitive {
  public:
    ///
    GX_CSG_Difference(const GXObjectList&);
    virtual ~GX_CSG_Difference(void);
    
    ///
    bool intersect(const GRay3&, GInterSectionList&);
    ///
    GVector3 getNormal(const GPoint3& rPoint);
    ///
    const GSurface& getSurface(const GPoint3&);

 private:
    GRayTraceable *mLastChild;
    GXObjectList mChildrenList;
    
    virtual const GBounds3& computeBounds(void);
};


#endif
