//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef __GX_SHADE_H__
#define __GX_SHADE_H__


/*
 * @CLASS@: GXShadingParams
 * 
 * @DESCR@: This class containts all parameters for shading calculation
 *  mP -> point to shade
 *  mN -> normal vector at this point
 *  mL -> incident light-vector
 *  mR -> specular reflection's vector
 *  mV -> view-vector (ray's direction)
 * 
 *  mSurface -> ptr to the surface of P
 *  mRayTracer  -> ptr to the camera, needed for rays tracing
 *  mPrimitive -> ptr to the primtive hited
 * 
 */
class GSurface;
class GXRayTracer;
class GRayTraceable;

class GXShadingParams {
 public:
    GVector3       mP, mN, mL, mR, mV; 
    bool           mEnter;
    GSurface*      mSurface;
    GRayTraceable* mPrimitive; 
    GXRayTracer*   mRayTracer;
    
    GXShadingParams(const GVector3& pP, const GVector3& pN, const GVector3& pL,
		    const GVector3& pR, const GVector3& pV, bool pEnter,
		    GSurface* pSurf, GRayTraceable *pPrim, GXRayTracer* pRT)
    :mP(pP), mN(pN), mL(pL), mR(pR), mV(pV), mEnter(pEnter),
     mSurface(pSurf), mPrimitive(pPrim), mRayTracer(pRT) {}
};

#endif
