//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef G_SERVER_H
#define G_SERVER_H

#include "input/gdevice.h"

//@ManMemo: Input server.
class GInputServer {
/*@DOC:
A server containing father-less input objects. These objects will be
polled in an endless loop.
*/
  public:
    GInputServer(void): mIDList(false) {}

    void add(GInputDevice* pDevice) {
	mIDList.append(pDevice);
    }
    void remove(GInputDevice* pDevice) {
	mIDList.remove(pDevice);
    }
    // non-blocking iteration about all input objects:
    void event(void);
  private:
    GDLList<GInputDevice> mIDList;
};

extern GInputServer gInputServer;

// endless input polling loop:
void gInputLoop(void);

#endif
