//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef G_TIME_H
#define G_TIME_H

#include "ggeneric.h"

//@ManMemo: Time data type.
class GTime {
/*@DOC:
Represenation of time in seconds and micro seconds after Jan. 1st 1970
*/
    friend ostream& operator<<(ostream&, const GTime&);
    friend GTime operator-(const GTime&, const GTime&);
    friend bool operator<(const GTime&, const GTime&);
    friend bool operator>(const GTime&, const GTime&);
  public:
    GTime(void);
    long getSeconds(void) const { 
	return(mSeconds); 
    }
    long getMicroSeconds(void) const { 
	return(mMicroSeconds); 
    }

    static GTime getTime(void) { 
	GTime tTime;
	return(tTime);
    } 
  private:
    long mSeconds; 
    long mMicroSeconds;
};

#endif
