//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef GTIMER_H
#define GTIMER_H

#include "input/gdevice.h"
#include "input/gtime.h"

//@ManMemo: A timer device.
class GTimer: public GInputDevice, public GTime {
  public:
    GTimer(GFloat pInterval): GInputDevice((GInputDevice*)gNoInputDevice), mInterval(pInterval) {}

    virtual bool event(GEvent* = 0);

    GFloat getInterval(void) const {
        return(mInterval);
    }
    void setInterval(GFloat pInterval) {
        mInterval = pInterval;
    }
  private:
    GFloat mInterval;
    GTime mTime;
};

#endif
