//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef G_UPDATE_H
#define G_UPDATE_H

#include "input/gdevice.h"
#include "render/gpixmap.h"

//@ManMemo: An update device.
class GUpdatePixmap: public GInputDevice {
  public:
    GUpdatePixmap(GPixmapDisplay& pDisp, GInputDevice* pFather = (GInputDevice*)gNoInputDevice): GInputDevice(pFather), mDisp(pDisp) {}

    GPixmapDisplay& getPixmapDisplay(void) const {
	return(mDisp);
    }

    virtual bool event(GEvent* pEvent) {
	bool ret = false;
	if (pEvent && pEvent->isA(gUpdatePixmapEventID)) {
	    if (((GUpdatePixmapEvent*)pEvent)->getPixmap() == &mDisp) {
		callCBs();
		ret = true;
	    }
	}
	GInputDevice::event(pEvent);
	return(ret);
    }
  private:
    GPixmapDisplay& mDisp;
};

#endif
