//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef G_PIXMAP_H
#define G_PIXMAP_H

#include "render/grealiz.h"
#include "util/gstring.h"
#include "util/gcolor.h"

class GPixmapDisplayData;
// DEFINED AND IMPLEMENTED PLATFORM DEPENDENT

//@ManMemo: Concrete realization class for rectangular pixel-based output.
class GPixmapDisplay: public GRealization {
    friend class GPixmapDisplayData;
  public:
    GPixmapDisplay(const GString&, int, int);
    // IMPLEMENTED PLATFORM DEPENDENT
    virtual ~GPixmapDisplay(void);
    // IMPLEMENTED PLATFORM DEPENDENT
    void putPixel(int, int, const GColorRGB&);
    // (0,0) is the lower left corner
    // IMPLEMENTED PLATFORM DEPENDENT
    GColorRGB getPixel(int, int);
    // (0,0) is the lower left corner
    // IMPLEMENTED PLATFORM DEPENDENT
    void clear(const GColorRGB&);
    // IMPLEMENTED PLATFORM DEPENDENT
    virtual void activate();
    // IMPLEMENTED PLATFORM DEPENDENT

    void setWidth(int pWidth) { mWidth = pWidth; } 
    int getWidth(void) const { return(mWidth); }

    void setHeight(int pHeight) { mHeight = pHeight; }
    int getHeight(void) const { return(mHeight); }

    bool inSingleBufferMode(void) const { return(mSglBuf); }

    GPixmapDisplayData& getData(void) { return(*mData); }

    virtual GEvent* getEvent(void);
    // IMPLEMENTED PLATFORM DEPENDENT

    virtual void swapBuffers(void);
    // IMPLEMENTED PLATFORM DEPENDENT
  private:
    int mWidth, mHeight;
    bool mSglBuf;
    GPixmapDisplayData* mData;
};

#endif
