//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifndef G_VARIABLE_H
#define G_VARIABLE_H

#include "util/gconstr.h"

//@ManMemo: Generic variable for DeltaBlue constraint solver.
class GDbVariable {
    friend class GDbConstraint;
    friend class GDbConstraintList;
  public:
    GDbVariable(char*, bool = false); // if true -> const 
    virtual ~GDbVariable(void);

    const char* getName(void) const { return (char*)mName; }
  public:
    GDbConstraintList constraints;
    GDbConstraint* determinedBy; 
    long mark;
    GDbStrength walkStrength;
    bool stay;
  protected:
    bool con;
  private:
    void removePropagateFrom(GDbConstraintList*); 
    void free(void);
    GDbConstraint* nextDownstreamConstraint(GDbConstraintList*);
    GString mName;
};

extern GDLList<GDbVariable>* gDbAllVariables;

#endif
