//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include "input/gdevice.h"
#include "input/gserver.h"

const GInputDevice* gNoInputDevice = 0;

GInputDevice::GInputDevice(GInputDevice *pFather): mFather(pFather), mState(true), cldList(true), cbList(false), mReal(0) { 
    if (mFather != gNoInputDevice) mFather->addChild(this);
    else gInputServer.add(this);
}

GInputDevice::~GInputDevice(void) { 
    if (mFather) mFather->removeChild(this);

    // remove it from the global list:
    gInputServer.remove(this); 
}

template<class C>
class GCallCallbackIterator: public GIterator<C> {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: An iterator that calls the
    // action method of all callbacks.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GCallCallbackIterator(GInputDevice& pDevice): mDevice(pDevice) {}
    virtual bool exec(C& c) {
	c.action(mDevice);
	return(false);
    }
  private:
    GInputDevice& mDevice;
}; 

void GInputDevice::callCBs() {
    GCallCallbackIterator<GCallback> tIter(*this);
    cbList.doWithElements(tIter);
}

bool GInputDevice::callChildren(GEvent* ev) {
    GPollInputDeviceIterator<GInputDevice> tIter(ev);
    cldList.doWithElements(tIter);
    return(!tIter.sleep());
}

