//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include "input/gfile.h"
#include "input/gselect.h"

#ifdef GSYSTEM_V
extern "C" void bzero(void *, int);
#endif

bool GFileDevice::event(GEvent* ev) {
    if (!isOn()) return(false);
    bool ret = false;
#ifdef GSYSTEM_V
    struct timeval wait; 
    // time out val
    wait.tv_sec = 0;
    wait.tv_usec = 0;

    fd_set rfds, wfds, efds;

    
    bzero(&rfds, sizeof(rfds)); 
    if (mMode & 1) FD_SET(mFD, &rfds);

    bzero(&wfds, sizeof(wfds)); 
    if (mMode & 2) FD_SET(mFD, &wfds);

    bzero(&efds, sizeof(efds)); 
    if (mMode & 4) FD_SET(mFD, &efds);

    if (select(FD_SETSIZE, &rfds, &wfds, &efds, &wait) > 0) {
	setTime(GTime::getTime());
	callCBs();
	ret = true;
    } 
#endif
    if (GInputDevice::event(ev)) ret = true;
    return(ret);
}
