//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include "input/gtime.h"

#ifdef GSYSTEM_V
#include <sys/time.h>
#endif

GTime::GTime(void) {
#ifdef GSYSTEM_V
    struct timeval tVal;
    gettimeofday(&tVal, 0);

    mSeconds = tVal.tv_sec;
    mMicroSeconds = tVal.tv_usec;
#endif
}

ostream& operator<<(ostream& pStream, const GTime& pTime) {
    GFloat tTime = pTime.mSeconds;
    tTime += pTime.mMicroSeconds/1000000.0;
    return(pStream << tTime);
}

GTime operator-(const GTime& pTime1, const GTime& pTime2) {
    GTime tTime;
    tTime.mSeconds = pTime1.mSeconds - pTime2.mSeconds;
    tTime.mMicroSeconds = pTime1.mMicroSeconds - pTime2.mMicroSeconds;
    if (tTime.mMicroSeconds < 0) {
	tTime.mSeconds -= 1;
	tTime.mMicroSeconds += 1000000;
    }
    return(tTime);
}
