//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include "model/gresol.h"

const GResolutionAttribute GResolutionAttribute::attribute;

GResolutionAttribute::GResolutionAttribute(GFloat pValue): GAttribute(attribute) { 
    setResolution(pValue); 
}

GResolutionAttribute::GResolutionAttribute(void): mResolution(0), GAttribute(attribute) {
    if (this == &attribute) {
	mResolution = new GResolution; 
	setExist();
    }
}

void GResolutionAttribute::setResolution(const GResolution& pResol) {
    if (!getExist()) {
	mResolution = new GResolution(pResol);
	setExist();
    }
    else mResolution->setResolution(pResol.getResolution());
    resolutionChanged();
}

const GResolution& GResolutionAttribute::getResolution(void) const {
    if (getExist()) return(*mResolution);
    else return(((const GResolutionAttribute&)getReference()).getResolution());
}

void GResolutionAttribute::reference(const GResolutionAttribute& pAttr) {
    if (getExist()) return;
    setReference(pAttr);
    resolutionChanged();
}


