//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include "render/grender.h"

GVector3 gCalcVUP(const GVector3& vp, const GVector3& rp, GFloat twist) {
    GVector3 xa, ya, vup;
    GVector3 dr = rp -vp;
    if (dr.mX == 0.0 && dr.mZ == 0.0) {
	xa = GVector3(1,0,0); 
	ya = GVector3(0,0,1); 
    } 
    else { 
	xa = dr.cross(GVector3(0,1,0));
	ya = dr.cross(xa); 
    }
    if (twist == 0.0) vup = ya;
    else {
	GVector3 xan = xa * sqrt(1/(xa.mX * xa.mX + xa.mY * xa.mY + xa.mZ * xa.mZ));
	GVector3 yan = ya * sqrt(1/(ya.mX * ya.mX + ya.mY * ya.mY + ya.mZ * ya.mZ));
	GVector3 d; 
	GFloat length;
	if (twist > 0 && twist <= M_PI_2) {
	    d = xan - yan;
	    length = sin(twist)/sin(M_PI - (M_PI_4 + twist));
	    vup = yan + d * sqrt(length * length/(d.mX * d.mX + d.mY * d.mY + d.mZ * d.mZ));
	}
	if (twist > M_PI_2 && twist <= M_PI) {
	    twist -= M_PI_2;
	    d = yan * (-1)-xan; 
	    length = sin(twist)/sin(M_PI - (M_PI_4 + twist));
	    vup = xan + d * sqrt(length * length/(d.mX * d.mX + d.mY * d.mY + d.mZ * d.mZ));
	}
	if (twist > M_PI && twist <= M_PI + M_PI_2) {
	    twist -= M_PI;
	    d = yan - xan;
	    length = sin(twist)/sin(M_PI - (M_PI_4 + twist));
	    vup = yan * (-1) + d * sqrt(length * length/(d.mX * d.mX + d.mY * d.mY + d.mZ * d.mZ));
	}
	if (twist > M_PI + M_PI_2 && twist <= M_PI + M_PI) {
	    twist -= M_PI + M_PI_2;
	    d = yan - xan * (-1);
	    length = sin(twist)/sin(M_PI - (M_PI_4 + twist));
	    vup = xan*(-1) + d * sqrt(length * length/(d.mX * d.mX + d.mY * d.mY + d.mZ * d.mZ));
	}
    }    
    return(vup);
}

