//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include "util/gfacet.h"

const int gNoVertexIndex = -1;

int GFacet::getVertexIndex(int vi) const {
    for (int i = 0; i < mIndex; i++) 
	if (vi == mArray[i]) return(i);

    return(gNoVertexIndex);
}

bool GFacet::isVertexInFacet(int ci) const { 
    for (int i = 0; i < mIndex; i++) 
	if (ci == mArray[i]) return(true);

    return(false);
}

bool GFacet::hasBadPointer(int maxPointer) const {
    bool ret = false;
    for (int i = 0; i < mIndex; i++) 
	if (mArray[i] > maxPointer) ret = true;

    return(ret);
}

void GFacet::set(int pIndex, const int* pArray) { 
    mIndex = pIndex;
    if (mArray) {
	delete mArray;
	mArray = 0;
    }
    if (!mIndex) return;
    mArray = new int[mIndex];
    for (int i = 0; i < mIndex; i++) mArray[i] = pArray[i]; 
}

ostream& operator<<(ostream& pStream, const GFacet& pFacet) {
    pStream << '{';
    for (int i = 0; i < pFacet.mIndex; i++) 
	pStream << pFacet.mArray[i] << ' ';

    return(pStream << '}');
}

