//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
//  LAST EDIT: Tue Dec  5 13:44:31 1995 by paul(@prakinf.tu-ilmenau.de)
#include "util/gsurface.h"

ostream& operator<<(ostream& pStream, const GSurface& pSurface) {
    pStream << '{' << pSurface.mAmbient << ' '
	<< pSurface.mDiffuse << ' '
	    << pSurface.mSpecular << ' ' << pSurface.mShininess << ' '
		<< pSurface.mRefraction << ' ' << pSurface.mTransparency << '}';
    return(pStream);
}

GSurface::GSurface(const GColorRGB& pColor) {
    setAmbient(pColor);
    setDiffuse(pColor);
    setSpecular(pColor);
    setShininess(30);
    setRefraction(1.0);
    setTransparency(0.0);
}

bool GSurface::operator==(const GSurface& pSurface) const {
    if(!(mAmbient == pSurface.mAmbient)) return false;
    if(!(mDiffuse == pSurface.mDiffuse)) return false;
    if(!(mSpecular == pSurface.mSpecular)) return false;
    if(!(mShininess == pSurface.mShininess)) return false;
    if(!(mRefraction == pSurface.mRefraction)) return false;
    if(!(mTransparency == pSurface.mTransparency)) return false;
    return true;
}

const GSurface gRedSurface = GSurface(GColorRGB(1.0, 0.0, 0.0));
const GSurface gGreenSurface = GSurface(GColorRGB(0.0, 1.0, 0.0));
const GSurface gBlueSurface = GSurface(GColorRGB(0.0, 0.0, 1.0));

