global fsb
set fsb(title) 		"TIGER-File"
set fsb(geo)		"450x350"
set fsb(dirW)		""
set fsb(fileW)		""
set fsb(filter) 	"*tcl*"
set fsb(top)		.fsbox
set fsb(curDir) 	[exec pwd]
set fsb(curFile)   	""
set fsb(selection)  	""

proc fsb::rescan {} {
    global fsb
    
    $fsb(dirW) delete 0 end
    $fsb(fileW)	delete 0 end
    catch {
	foreach i [exec ls -a $fsb(curDir)] {
	    if {[file isdirectory $fsb(curDir)/$i]} {
		if {$fsb(curDir)=="/"} {
		    $fsb(dirW) insert end "/$i"
		} else {
		    $fsb(dirW) insert end "$fsb(curDir)/$i"
		}
	    } elseif {[file isfile $fsb(curDir)/$i] &&\
		[string match $fsb(filter) $i] } {
		$fsb(fileW) insert end $i
	    }
	}
    }
    set fsb(selection) $fsb(curDir)
}

proc fsb {{pMessage "Select File"}} {
    global fsb

    catch { destroy $fsb(top) } 
    toplevel $fsb(top)
    wm title $fsb(top) $fsb(title)
    wm geometry $fsb(top) $fsb(geo)
    wm protocol $fsb(top) WM_DELETE_WINDOW {
	global fsb
	set fsb(selection)  ""
	destroy $fsb(top)
    }
    label $fsb(top).l0\
	-text "$pMessage"
    label $fsb(top).l1\
	-anchor w\
	-text Filter:
    entry $fsb(top).filter\
	-textvariable fsb(filter)
    bind $fsb(top).filter <Return> {
	fsb::rescan
    }
    pack $fsb(top).l0 $fsb(top).l1 $fsb(top).filter\
	-side top\
	-fill x
    frame $fsb(top).f\
	-bd 0\
	-relief flat
    pack $fsb(top).f\
	-fill both\
	-expand yes
    frame $fsb(top).f.directories\
	-bd 0\
	-relief flat
    place $fsb(top).f.directories\
	-x 0\
	-y 0\
	-relwidth 0.6\
	-relheight 1
    scrollbar $fsb(top).f.directories.s1 \
	-width 10\
	-command "$fsb(top).f.directories.l yview"
    pack $fsb(top).f.directories.s1\
	-padx 0\
	-pady 0\
	-side right\
	-fill y
    scrollbar $fsb(top).f.directories.s2 \
	-orient horizontal\
	-width 10\
	-command "$fsb(top).f.directories.l xview"
    pack $fsb(top).f.directories.s2\
	-padx 0\
	-pady 0\
	-side bottom\
	-fill x

    listbox $fsb(top).f.directories.l \
	-yscroll "$fsb(top).f.directories.s1 set"\
	-xscroll "$fsb(top).f.directories.s2 set"
    pack $fsb(top).f.directories.l\
	-padx 0\
	-pady 0\
	-side left\
	-fill both\
	-expand yes
    bind $fsb(top).f.directories.l <Double-Button-1> {
	global fsb
	set tDir [%W get [%W nearest %y]]
	set tTmp [string range $tDir [string last / $tDir] [string length $tDir]]
	if {$tTmp=="/.."} {
	    set fsb(curDir) [string range $fsb(curDir) 0 [expr [string last / $fsb(curDir)]-1]]
	    if {$fsb(curDir)=={}} { set fsb(curDir) / }
	} elseif {$tDir!="/." && $tTmp!="/." && [file isdirectory $tDir]} {
	    set fsb(curDir) $tDir
	}
	fsb::rescan
    }
    set fsb(dirW) $fsb(top).f.directories.l
    frame $fsb(top).f.files\
	-bd 1\
	-relief ridge
    place $fsb(top).f.files\
	-relx 0.6\
	-y 0\
	-relwidth 0.4\
	-relheight 1
    scrollbar $fsb(top).f.files.s1 \
	-width 10\
	-command "$fsb(top).f.files.l yview"
    pack $fsb(top).f.files.s1\
	-padx 0\
	-pady 0\
	-side right\
	-fill y
    scrollbar $fsb(top).f.files.s2 \
	-orient horizontal\
	-width 10\
	-command "$fsb(top).f.files.l xview"
    pack $fsb(top).f.files.s2\
	-padx 0\
	-pady 0\
	-side bottom\
	-fill x
    listbox $fsb(top).f.files.l \
	-yscroll "$fsb(top).f.files.s1 set"\
	-xscroll "$fsb(top).f.files.s2 set"
    pack $fsb(top).f.files.l\
	-padx 0\
	-pady 0\
	-side left\
	-fill both\
	-expand yes
    bind $fsb(top).f.files.l <ButtonPress-1> {
	global fsb
	set fsb(curFile) [%W get [%W nearest %y]]
	if {$fsb(curDir)=="/"} {
	    set fsb(selection) "/$fsb(curFile)"
	} else {
	    set fsb(selection) "$fsb(curDir)/$fsb(curFile)"
	}
    }
    bind $fsb(top).f.files.l <Double-Button-1> {
	global fsb
	set fsb(curFile) [%W get [%W nearest %y]]
	catch { after 250 { destroy $fsb(top) } }
    }
    set fsb(fileW) $fsb(top).f.files.l
    label $fsb(top).l2\
	-anchor w\
	-text Selection:
    entry $fsb(top).selection\
	-textvariable fsb(selection)
    pack $fsb(top).l2 $fsb(top).selection\
	-fill x
    bind $fsb(top).selection <Return> {
	global fsb
	destroy $fsb(top)
    }
    frame $fsb(top).buttons\
	-bd 0\
	-relief flat
    button $fsb(top).buttons.ok\
	-width 10\
	-text Ok\
	-command {
	    global fsb
	    destroy $fsb(top)
	}
    button $fsb(top).buttons.filter\
	-width 10\
	-text Filter\
	-command {
	    fsb::rescan
	}
    button $fsb(top).buttons.cancel\
	-width 10\
	-text Cancel\
	-command {
	    global fsb
	    set fsb(selection) ""
	    destroy $fsb(top)
	}
    pack $fsb(top).buttons.ok $fsb(top).buttons.filter $fsb(top).buttons.cancel\
	-padx 20\
	-pady 10\
	-side left\
	-fill x
    pack $fsb(top).buttons
    fsb::rescan
    grab $fsb(top)
    tkwait window $fsb(top)
    if {[file isfile $fsb(selection)]} { return "$fsb(selection)" }
}
