# Variables for Manpage
set ManHistory {}
set Pages {}

# Functions for Manpages

proc Manual {name menu} {
    set i 0
    foreach e [gtHelp[set name]] {
	if {[llength $e] == 1 } {
	    $menu add cascade\
		-label $e\
		-menu $menu.m$i
	    menu $menu.m$i
	    Manual $e $menu.m$i
	    incr i
	} {
	    $menu add command\
		-label [lindex $e 0]\
		-command "ManPage [lindex $e 1]" 
	}
    }
}

proc NoFunction {} {}

proc Man { widget } {

set word [$widget get \
	"insert wordstart" \
	"insert wordend"]

# check the word of "" or " " and call man
if {[string length $word] && [string compare $word " "]} {
    ManPage $word }
}

proc ManPage {page} {
    global ManHistory

    catch "exec man $page | col -b" Text
    if [regexp "No manual entry" $Text]  {
	PP_manInit $page $Text
	return
    } {
	set ManHistory "$ManHistory $page" 
	PP_manInit $page $Text
	return
    }
}	

proc PreviousMan {} {
    global ManHistory
    set length [llength $ManHistory]
    set Tmp $ManHistory
    set word       [lindex $ManHistory [expr $length-2]]
    set ManHistory [lrange  $ManHistory 0 [expr $length-3]]
    # check the word of "" or " " and call man
    if {[string length $word] && [string compare $word " "]} {
	ManPage $word 
    } {
	set ManHistory $Tmp
    }
}

proc PP_manInit {Titel Text} {
    if {0==[string length [info commands .manMMM]]} {

	# build widget .manMMM
	toplevel .manMMM 
	
	# Window manager configurations
	wm title .manMMM {TIGER-manual}
	wm maxsize .manMMM 1000 1000
	wm minsize .manMMM 10 10
	
	# build widget .manMMM.frame4
	frame .manMMM.frame4
	.manMMM.frame4 configure \
		-borderwidth {2}\
	        -width 30\
                -height 30
	
	# build widget .manMMM.frame4.button6
	button .manMMM.frame4.button6
	.manMMM.frame4.button6 configure \
		-command {PP_manExit}\
		-text {OK}
	
	# pack widget .manMMM.frame4
	pack append .manMMM.frame4\
		.manMMM.frame4.button6   {top frame center fill} 
	
	# build widget .manMMM.frame2
	frame .manMMM.frame2
	.manMMM.frame2 configure \
		-borderwidth {2}\
                -width 50\
                -height 50\
		-relief {raised}
	
	# build widget .manMMM.frame2.frame
	frame .manMMM.frame2.frame
	
	# build widget .manMMM.frame2.frame.scrollbar1
	scrollbar .manMMM.frame2.frame.scrollbar1
	.manMMM.frame2.frame.scrollbar1 configure \
		-command {.manMMM.frame2.frame.text2 yview}\
		-width {10}
	
	# build widget .manMMM.frame2.frame.text2
	text .manMMM.frame2.frame.text2
	.manMMM.frame2.frame.text2 configure \
		-relief {sunken}\
		-height {35}\
		-width {80}\
		-yscrollcommand {.manMMM.frame2.frame.scrollbar1 set}\
		-wrap {word}\
	        -relief flat
	# bindings
	bindtags .manMMM.frame2.frame.text2 {all}
	bind .manMMM.frame2.frame.text2 <ButtonRelease-3> {PreviousMan}
	bind .manMMM.frame2.frame.text2 <Any-Key> {NoFunction} 

	# pack widget .manMMM.frame2.frame
	pack append .manMMM.frame2.frame\
		.manMMM.frame2.frame.scrollbar1   {right frame center filly} \
		.manMMM.frame2.frame.text2   {top frame center expand fill} 
	
	# pack widget .manMMM.frame2
	pack append .manMMM.frame2\
		.manMMM.frame2.frame   {top frame center expand fill} 
	
	# build widget .manMMM.frame1
	frame .manMMM.frame1
	.manMMM.frame1 configure \
		-borderwidth {2}\
	        -width 30\
                -height 30\
		-relief {raised}
	
	# build widget .manMMM.frame1.label3
	label .manMMM.frame1.label3

	# build widget .manMMM.frame1.menubutton_help
	#  menubutton .manMMM.frame1.menubutton_help
	#  .manMMM.frame1.menubutton_help configure \
		#    -cursor {arrow}\
		#    -text { Help }
	#    -menu {.helpmenu}\
		
	
	# bindings
	#  tk_bindForTraversal .manMMM.frame1.menubutton_help
	#  bind .manMMM.frame1.menubutton_help <F10> {tk_firstMenu %W} 
	#  bind .manMMM.frame1.menubutton_help <Mod2-Key> {tk_traverseToMenu %W %A} 

	# build widget .manMMM.frame1.menubutton_pages
	menubutton .manMMM.frame1.menubutton_pages
	.manMMM.frame1.menubutton_pages configure \
		-cursor {arrow}\
		-menu {.manMMM.frame1.menubutton_pages.m}\
		-text { Pages}
	# bindings
	tk_bindForTraversal .manMMM.frame1.menubutton_pages
	bind .manMMM.frame1.menubutton_pages <F10> {tk_firstMenu %W} 
	bind .manMMM.frame1.menubutton_pages <Mod2-Key> {tk_traverseToMenu %W %A} 
	
	menu .manMMM.frame1.menubutton_pages.m

	# build widget .manMMM.frame1.button
	button .manMMM.frame1.button
	.manMMM.frame1.button configure \
		-command {PreviousMan}\
		-padx {2}\
		-pady {1}\
		-text {Previous}\
		-relief {flat}

	# pack widget .manMMM.frame1
	# .manMMM.frame1.menubutton_help   {left   } 
	pack append .manMMM.frame1\
		.manMMM.frame1.menubutton_pages   {left   } \
		.manMMM.frame1.label3   {left frame center expand fill} \
		.manMMM.frame1.button   {right  } 

	# pack widget .manMMM
	pack append .manMMM\
		.manMMM.frame1   {top frame center fillx} \
		.manMMM.frame2   {top frame center expand fill} \
		.manMMM.frame4   {top frame center fillx} 
	
    }

    .manMMM.frame2.frame.text2 delete 1.0 end
    .manMMM.frame2.frame.text2 insert end "$Text"
    
    if [regexp "No manual" $Text] {} {
	destroy .manMMM.frame1.menubutton_pages.m
	global Pages
	if {-1==[lsearch $Pages $Titel]} {
	    lappend Pages $Titel
	}
	
	if {[llength $Pages]>15} {
	    set Pages [lreplace $Pages 0 0]
	}
	menu .manMMM.frame1.menubutton_pages.m
	foreach page [lsort $Pages] {
	    .manMMM.frame1.menubutton_pages.m add command -label $page -command "ManPage $page" }
	}
	.manMMM.frame1.label3 configure \
		-foreground {red}\
		-text "$Titel" 
}
    
proc PP_manExit {} {
    global PP_ManActive
    set PP_ManActive 0
    destroy .manMMM	
}
