//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel, Version 1.5.
//  Copying, distribution and legal info is in the file COPYRGHT which should
//  be distributed with this file. If COPYRGHT is not available or for more
//  info please contact	generic@prakinf.tu-ilmenau.de (in English, please).
//  This project is sponsored by EasternGraphics GmbH, Germany.
/////////// (C) '96 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include <render/gpixmap.h>
#include <render/graycam.h>
#include <render/grayligh.h>
#include <input/gtime.h>
#include <util/gtempl.h>

int main(void) {
    const GColorRGB cPink(0.5, 0.0, 0.7);

    // initialize GENERIC:
    gInitialize();

    // create a pixmap display to be used for
    // ray-tracing output:
    GPixmapDisplay tPixmap("GTest", 200, 200);
    
    // create an aggregate representing a scene:
    GDLList<GRayTraceable> tScene(false);

    // put an object into the scene:
    tScene.append(new GRayTraceableSphere);

    // initialize global ray-tracing light source aggregate:
    gRayLights = new GDLList<GRayLight>(false);

    // create a point light:
    GRayPointLight tLight;
    tLight.setPosition(GPoint3(3, 3, 3));
    tLight.setColor(GColorRGB(1, 1, 0));

    GDLList<GRayLight>* tLights = new GDLList<GRayLight>(false);
    // insert light:
    tLights->append(&tLight); 

    // initialize global shading light source aggregate:
    gRayLights = tLights;

    // create the renderer:
    GLookatRayTracer<GRayTraceable, GPixmapDisplay> tRenderer;
    tRenderer.setBackground(cPink);

    // create the output:
    tRenderer.initRealization(tPixmap);

    GTime tTime;
    tRenderer.rendering(tScene);
    cout << "Rendering time: " << GTime::getTime() - tTime << " secs" << endl;

    getchar();
    return(0);
}
